<p align="center">
  <img src="../media/logo.png" height="128"/>
</p>

# TF Watcher (Webapp)

[![Azure Static Web Apps CI/CD](https://github.com/Rishit-dagli/TF-Watcher/actions/workflows/azure-static-web-apps-ashy-ocean-0e69e8700.yml/badge.svg)](https://github.com/Rishit-dagli/TF-Watcher/actions/workflows/azure-static-web-apps-ashy-ocean-0e69e8700.yml)

_**TF Watcher Webapp**_ is built with React, Chakra-UI and Firebase SDK.
The main aim of this application is to monitor ML training or testing process. It is connected with Firebase, to get
real time updates and show graphs for the same.

[_**Visit the deployed website**_](https://www.tfwatcher.tech/) to test it out.

## Features 👓

- [x] Authentication
- [x] Connecting with Firebase Realtime Database
- [x] Read data and format it to display charts
- [x] Deployed to Azure Static Webapp
- [ ] Tests (WIP)

## About this project 💡

The project has two main screens:

- [**`Home`**](/src/screens/HomeScreen.js): Displays the home screen, where the user can enter the key generated by [Python package](https://github.com/Rishit-dagli/TF-Watcher/tree/main/tfwatcher)
- [**`Charts`**](/src/screens/ChartScreen.js): Displays the real-time charts for the entered key

Firebase Instance: 
- [**`Firebase`**](/src/firebase/Firebase.js): Configure the Firebase Instance and leverages its functionality for authentication and accessing real-time data.

## Development Setup 🖥️

You will require Yarn or npm to be able to run this application locally. Download npm from [here](https://docs.npmjs.com/downloading-and-installing-node-js-and-npm) and Yarn from [here](https://classic.yarnpkg.com/en/docs/install#windows-stable)

To setup `tfwatcher webapp` and get all its dependencies, run the following:

```sh
git clone https://github.com/Rishit-dagli/TF-Watcher.git
# or clone your own fork

cd webapp
yarn install
```

To run the application locally:
```
yarn start
```

To create a build version:
```
yarn run build
```

## Built with 🛠

- [React](https://reactjs.org/) - A JavaScript library for building user interfaces
- [Create-React-App](https://create-react-app.dev/) - A library used to bootstrap React application
- [Chakra UI](https://chakra-ui.com/) - A UI library to create accessible React apps with speed
- [Firebase](https://firebase.google.com/) - Accelerate and scale app development with fully managed backend infrastructure
  - [Realtime Database](https://firebase.google.com/products/realtime-database) - Cloud-hosted NoSQL database to store and sync dataa in rwaltime
  - [Authentication](https://firebase.google.com/products/auth) - Simple, free multi-platform sign-in
- [Recharts](https://recharts.org/en-US/) - A charting library to built on React components
- [Azure Static Web Apps](https://azure.microsoft.com/en-us/services/app-service/static/) - Used to deployment and CI/CD
